require 'polirb/client'
require 'polirb/errors'
require 'polirb/static'
require 'polirb/request'
require 'polirb/version'

module Polirb
  @@options = {}

  # Create a new Polirb::Client instance
  #
  def self.new(options={})
    Polirb::Client.new(options)
  end

  # Define a global configuration
  #
  # options[:merchant_code]
  # options[:authentication_code]
  # options[:merchant_homepage_url]
  # options[:success_url]
  # options[:failure_url]
  # options[:cancellation_url]
  # options[:notification_url]
  # options[:timeout]
  #
  def self.configure(options={})
    unless options.kind_of?(Hash)
      raise ArgumentError, "Options hash required."
    end

    @@options[:merchant_code]         = options[:merchant_code]
    @@options[:authentication_code]   = options[:authentication_code]
    @@options[:merchant_homepage_url] = options[:merchant_homepage_url]
    @@options[:success_url]           = options[:success_url]
    @@options[:failure_url]           = options[:failure_url]
    @@options[:cancellation_url]      = options[:cancellation_url]
    @@options[:notification_url]      = options[:notification_url]
    @@options[:timeout]               = options[:timeout]
    @@options
  end

  # Returns global configuration hash
  #
  def self.configuration
    @@options
  end

  # Resets the global configuration
  #
  def self.reset_configuration
    @@options = {}
  end
end
