require 'polirb/client'
require 'polirb/request'
require 'polirb/static'
require 'polirb/client/transactions'

module Polirb
  class Client
    include Polirb::Request
    include Polirb::Static
    include Polirb::Transactions

    attr_reader :merchant_code, :authentication_code, :merchant_homepage_url, :success_url, :failure_url, :cancellation_url, :notification_url, :timeout

    # Initialize a Polirb::Client instance
    #
    # options[:merchant_code]
    # options[:authentication_code]
    # options[:merchant_homepage_url]
    # options[:success_url]
    # options[:failure_url]
    # options[:cancellation_url]
    # options[:notification_url]
    # options[:timeout]
    #
    def initialize(options={})
      unless options.kind_of?(Hash)
        raise ArgumentError, "Options hash required."
      end

      @merchant_code          = options[:merchant_code]
      @authentication_code    = options[:authentication_code]
      @merchant_homepage_url  = options[:merchant_homepage_url]
      @success_url            = options[:success_url]
      @failure_url            = options[:failure_url]
      @cancellation_url       = options[:cancellation_url]
      @notification_url       = options[:notification_url]
      @timeout                = options[:timeout]
    end
  end
end
