module Polirb
  class Error                                           < StandardError; end
  # class ConfigurationError                              < Error; end
  # class Unauthorized                                    < Error; end
  # class NotFound                                        < Error; end
end


# 1001	Invalid Token	The token specified in the request corresponds to a POLi ID that does not exist in the database.	Please contact POLi Support.
# 1002	Illegal Token	The token specified in the request corresponds to a POLi ID that does not belong to the specified merchant.	Please confirm that the specified merchant code is correct. If the issue persists please contact POLi Support.
# 1003	Invalid Merchant Code	The merchant code specified in the request does not exist in the database.	Please check that you have input the given merchant code correctly. If you are sure you have, please contact POLi Support.
# 1004	Inactive Merchant	The merchant code specified in the request corresponds to a merchant that is inactive.	The merchant code you are using has been set to inactive. If you think this is an error, please contact POLi Support.
# 1005	Merchant Not Authenticated	The merchant authentication code supplied is not correct or the authentication type has not been specified in the POLi™ system.	Please check you have put the correct authentication code in for your merchant code. If you are certain you have, please contact POLi Support.
# 1006	Deleted Merchant	The merchant code specified in the request corresponds to a merchant that has been deleted.	The merchant code you are using has been deleted. If you think this is an error, please contact POLi Support.
# 1007	Invalid Currency Code	The specified currency code does not exist in the database.	The currency code you are attempting to use is invalid. Please note that the only acceptable options are AUD and NZD.
# 1008	Invalid Merchant Currency	The specified currency code does not correspond to an active currency for the specified merchant.	The merchant you are using is set up for a different currency code than the one you provided.
# 1009	Currency System Limit Exceeded	The payment amount in the specified currency has exceeded the system limit for that currency.	Inform the customer that POLi™ applies transaction limits for security reasons and to try another payment limit. Do not specify the limit. If you would like to change your limit, please contact POLi Support.
# 1010	Currency VAR Limit Exceeded	The payment amount in the specified currency has exceeded the VAR limit for that currency.	Inform the customer that POLi™ applies transaction limits for security reasons and to try another payment limit. Do not specify the limit. If you would like to change your limit, please contact POLi Support.
# 1011	Currency Merchant Single Transaction Limit Exceeded	The payment amount in the specified currency has exceeded the merchant’s single transaction limit for that currency.	Inform the customer that POLi™ applies transaction limits for security reasons and to try another payment limit. Do not specify the limit. If you would like to change your limit, please contact POLi Support.
# 1012	Currency Merchant Daily Cumulative Limit Exceeded	The payment amount in the specified currency has exceeded the merchant’s daily cumulative limit for that currency.	Inform the customer that POLi™ applies transaction limits for security reasons and to try another payment limit. Do not specify the limit. If you would like to change your limit, please contact POLi Support.
# 1013	Invalid Merchant Established Date Time	The difference between the specified merchant established time and the system time is more than 24 hours.	Check your date and time settings.
# 1014	Invalid URL Format	The format of the specified URL is invalid.	Please check the URL fields in your initiate data and ensure they are correct.
# 1015	Invalid timeout value	The specified timeout value is less than the system minimum timeout value.	Please check the Timeout field you provided in your initiate data.
# 1016	The transaction has expired	The transaction being enquired upon has lapsed past the 15min enquiry window	Use the Merchant Console to attain the outcome of this transaction
# 1017	Blocked User IP address	The IP address of the user is blocked, restricted or otherwise from a list of known suspect IP addresses	Do not try to initiate a transaction again. NOTE: Strongly recommend that the user not be allowed to complete the transaction using another payment option at the Merchant’s discretion.
# 1018	Invalid IP address format	The IP address is in an invalid format	Try again passing in the correct data
# 1019	Invalid IP address	The IP address is invalid	Try again passing in the correct data
# 1020	No merchant primary account	The merchant has not set up a primary account to be used	Set up a primary account for the merchant through the console and try initiating the transaction again after it has been successfully added.
# 1021	Invalid Field Characters	The specified field contains invalid characters.	Make sure there are no special characters in invalid fields.
# 1022	Mandatory Field	No value is supplied for a mandatory field.	A field considered mandatory has no data in it.
# 1023	Invalid Field Length	The specified field has an invalid length.	The data you have specified for a field is either too long or too short. Please verify the requirements for the field and retry.
# 1024	Invalid Currency Amount In Field	The specified field contains invalid currency amount.	The amount format is incorrect. Please ensure that no fewer or greater than two decimal places are specified.
# 1025	Invalid Field Range	The value in the field is out of the allowable range.	Please check the values and make sure they are within acceptable ranges.
# 1026	Invalid Transaction Status	The transaction has not followed the anticipated transaction status path	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 1027	Invalid Merchant Financial Institution	The Financial Institution Code passed in is not allowed for this merchant	This merchant does not allow the bank you attempted to select.
# 1028	Invalid Financial Institution Code	The Financial Institution Code passed in is not valid	POLi does not support the bank you attempted to select.
# 1029	Inactive Financial Institution	The Financial Institution Code passed in is not currently active	The financial institution you selected is currently inactive.
# 1030	Deleted Financial Institution	The Financial Institution Code passed in has been deleted	The financial institution you selected has been deleted.
# 1031	Invalid Financial Institution Vector	The vector for the passed in Financial Institution Code is not available or nonexistent	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 1032	Invalid Transaction Status Code	The Transaction Status Code passed in is not valid	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 1033	Invalid Transaction Status Codes	The Transaction Status Codes passed in are not valid	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 1034	Invalid entity code	The merchant code is not valid.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 1035	Inactive entity code	The entity code is not active.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 1036	Deleted entity code	The entity code has been deleted.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support..
# 1037	Either the TransactionRefNo or the MerchantReference must be supplied	The TransactionRefNo or MerchantReference passed in incorrect.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2001	Invalid Token	The token is invalid.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2002	Expired Token	The current token has timed out.	The transaction has expired. Please retry your payment.
# 2003	Illegal Token	The token is illegal.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2004	Invalid merchant code	The merchant code passed is invalid	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2005	Inactive merchant code	The merchant code passed is marked as inactive	The merchant code has been set to inactive. Please contact POLi Support if you think this is an error.
# 2006	Deleted merchant code	The merchant code passed has been deleted	The merchant code passed has been deleted. Please contact POLi Support if you think this is an error.
# 2007	Invalid transaction status	The transaction status was not as expected.	This may point to a problem with the bank site. Contact POLi support for more details.
# 2008	Invalid payment amount	The payment amount was invalid	The amount paid for the transaction was not what was expected. Contact POLi support for more details.
# 2009	Invalid merchant name	The merchant name is invalid	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2010	Invalid merchant sort code format	The sort code format is invalid	The BSB or sort code was not what was expected. Contact POLi support for more details.
# 2011	Invalid merchant account number format	The merchant account number format is invalid	The account number was not what was expected. Contact POLi support for more details.
# 2012	Invalid language code	The language code is invalid	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2013	Invalid Financial Institution code	The financial institution code is invalid	The FI code attempted was not found. Contact POLi support for more details.
# 2014	Invalid merchant financial institution	The merchant financial institution is invalid	The FI code was not valid. Contact POLi support for more details.
# 2015	Inactive financial institution	The financial institution passed is inactive	The FI code attempted was unavailable. Contact POLi support for more details.
# 2016	Non-existent financial institution vector	The vector for the given financial institution does not exist	The FI code attempted was unavailable. Contact POLi support for more details.
# 2017	Invalid transaction reference format	The transaction reference format was unexpected	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2018	Invalid Eula language	The Eula language was invalid	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2019	Deleted Financial Institution	The financial institution was deleted	The FI code attempted was unavailable. Contact POLi support for more details.
# 2020	Invalid transaction ref no	The transaction ref no is invalid	The transaction reference number was invalid. Contact POLi support for more details.
# 2021	Invalid Payment Amount	The amount being paid is not equal to the transaction amount	The user’s locale can affect the way that currency amounts are displayed on the screen. For example, a German locale may display the amount with a comma rather than a decimal point. This affects the way that POLi™ interprets the amount and may result in a failure. Setting the locale to En-AU, En-US, or En-GB will rectify this issue.
# 2022	Invalid merchant sort code	The merchant sort code does not equal the {4} sort code.	The sort code or BSB was invalid. Contact POLi support for more details.
# 2023	Invalid merchant account number	The merchant account number does not equal the {4} account number	The account number was invalid. Contact POLi support for more details.
# 2024	Invalid URL format	Invalid URL format	The URL format for one of the URL fields provided in the initiate data was invalid. Check your web services.
# 2025	Invalid step sequence	Invalid step sequence	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2026	Invalid step type code	Invalid step type code	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2027	Invalid POLi ID	Invalid POLi ID	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2028	Invalid Certificate	Invalid Certificate	The certificate supplied by the bank is invalid. Please note this error only applies to the downloadable POLi Browser client
# 2029	No start up details found	No start up details found	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2030	No time remaining found	No time remaining found	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2031	Invalid IP address format	The IP address format was incorrect	Please ensure the IP address has been passed in correctly.
# 2032	Invalid IP address	The IP address has changed during the payment	Retry the transaction. This may be caused by a momentary loss of connection, such as a mobile device changing from WiFi to 3G or 4G.
# 2033	Invalid vector signature	Invalid vector signature	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2034	Invalid merchant suffix format	Invalid merchant suffix format	The suffix provided was in an incorrect format. Contact POLi support for more details.
# 2035	The merchant account suffix does not equal the account suffix	The bank account suffix being paid to does not equal to the account suffix set up by the merchant.	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2036	Unsupported wininet version	POLi was unable to access the bank security information	The certificate supplied by the bank cannot be accessed. Please note this error only applies to the downloadable POLi Browser client
# 2037	Missing transaction data signing certificate	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2038	Error signing transaction data	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 2039	Second POLi Browser detected	POLi has detected 'POLiBrowser.exe' is already running	Reboot your computer to fix this issue
# 2040	Invalid payee reference	The Payee Reference was different to the one expected.	This can be caused by a customer changing the reference, or an error. Contact POLi support for more details.
# 2041	Invalid date time	The date and time POLi collected from the bank page is not what was expected	Retry your transaction, or contact POLi support for more details.
# 3001	Invalid token	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3002	Expired token	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3003	Illegal Token	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3004	Invalid merchant	The merchant code was invalid.	Contact POLi support for more details.
# 3005	Inactive merchant	The merchant code has been set to Inactive.	Contact POLi support for more details.
# 3006	Deleted merchant	The merchant code has been deleted.	Contact POLi support for more details.
# 3007	Invalid transaction status	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3008	Invalid financial institution code	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3009	Invalid merchant financial institution	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3010	Inactive financial institution	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3011	Invalid financial instituiton vector	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3012	Invalid language code	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3013	Invalid country code	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3014	Invalid currency code	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3015	Invalid eula language	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3016	Deleted financial institution	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3017	Invalid merchant terms and conditions language	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3018	Invalid URL format	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3019	Invalid step type code	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3020	Invalid eula version	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3021	Invalid FAQ language	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3022	The financial institution	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3023	The transaction has expired	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3024	No helper pane details found	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3025	No failure details found	NOTE: This error should never be returned to a Merchant. If it does then please inform POLi Support.
# 3026	User time out of sync	The user's local time and timezone is out of sync with the POLi Server.	Please check that the time, date and time zone are correct on your computer
# 3027	Invalid IP Address format
# 3028	Invalid IP Address	The IP address has changed during the payment	Retry the transaction. This may be caused by a momentary loss of connection
# 3029	No merchant checkout URL	The IP address has changed during the payment	Retry the transaction. This may be caused by a momentary loss of connection
# 3030	The transaction was terminated in an unknown state	The transaction passed its timeout value while in Unknown status	This may point to a problem with the customer's bank. Please contact POLi Support for more details.
# 3031	Payment URL for merchant has expired	Payment url has expired	There may be an error in the implementation of POLi™. Check your web services.
# 3033	Payment URL is not valid	Payment URL is invalid	An invalid POLiLinkURL has been attempted
# 3034	Failed to update customer id	Non Fatal Error
# 3035	Failed to update transactions top up indicator	Non Fatal Error
# 4001	Unknown Error	An internal error has occurred	Please retry your POLi payment. If the error persists, please contact the merchant, quoting the POLi ID.
# 4005	Null Result Error	Bank page is not recognised by POLi.	POLi has encountered an unexpected bank page. This may be due to a new or changed bank page. Our support team has been advised of the error and will address this error as soon as possible.
# 4007	Invalid Transaction Status	The transaction status was not as expected.	This may point to a problem with the bank site. Contact POLi support for more details.
# 4030	ThreatMetrix rejected this user	An error has occurred. Please contact the merchant for more information.
# 4031	Payment Data Not Matched	The payment information is missing or has changed	This may point to a problem with the bank site. Contact POLi support for more details.
# 4032	Unhandled Exception	An exception has occurred during payment	This may point to a problem with the bank site. Contact POLi support for more details.
# 4033	Unhandled HttpRequestException	An HTTP Request exception has occurred during payment	This may point to a problem with the bank site. Contact POLi support for more details.
# 4034	JavaScript execution failed	An error has occurred executing Javascript during the transaction.	This may point to a problem with the bank site. Contact POLi Support for more details.
# 4040	Blacklisted Account	Please contact POLi Support for further information.
# 4050	Merchant account details Invalid	The merchant's account is not valid	Please contact POLi Support for more information or update your merchant bank account.
# 4051	Internet banking locked	Your internet banking service is locked. Please contact your bank for further details.
# 4052	Third-party payments not supported	Your account does not support third-party payments. Please contact your bank for further details.
# 5001	An unknown error as occured	Please contact POLi Support for more details.
# 5002	No transaction token	Please contact POLi Support for more details.
# 5003	Client certificate error	Please contact POLi Support for more details.
# 5004	Unable to execute	The transaction cannot proceed as it is not in an active state	Retry the payment. Contact your merchant if the issue persists.
# 5005	Unexpected page	POLi has encountered an unexpected bank page.	This may be due to a new or changed bank page. Our support team has been advised of the error and will address this error as soon as possible.
# 5006	Null reference error	POLi has encountered an error with a bank page.	This may be due to an changed bank page, your payment timing out, or as a result of multiple errors.
# 5007	Null or empty string	POLi has encountered an error with a bank page or field.	This may be due to an changed bank page, your payment timing out, or as a result of multiple errors.
# 5008	IE Invalid SSL Error	POLi is unable to verify the bank's security certificate.
# 5009	Host invalid SSL error	POLi is unable to verify the bank's security certificate. The bank may have recently updated their security certificate, or the bank website is currently unavailable.
# 5010	Disabled JavaScript	JavaScript may not be enabled or is blocked by a browser extension.	Please enable javascript in your browser and try again
# 5011	Unable to obtain vector	POLi cannot proceed due to an error.	An internal error has occurred.
# 5012	Vector error	An internal error has occurred.
# 5013	Vector processing error	An internal error has occurred.
# 5014	Communication error	There is an error communicating with POLi server. This may be caused by a connection dropout or firewall settings on your computer.
# 5015	Host error	The POLi server has returned an error when processing the transaction. Please retry your POLi payment.
# 5016	Action Initiated Abort	An internal error has occurred.
# 5017	Vector XML Reader error	An internal error has occurred.
# 5018	Vector XML Deserialise Error	POLi is unable to continue due to an internal error.
# 5019	Unsupported Wininet version	Error no longer in use.	An internal error has occurred.
# 5020	Vector Signature Mismatch	An internal error has occurred.
# 5021	Page Data Mismatch	Non-fatal error	Logging information only.
# 5022	Null Vector	An internal error has occurred.
# 5023	No financial institution details in vector	An internal error has occurred.
# 5024	No financial institution start URL in vector	An internal error has occurred.
# 5025	No trace dump filter in vector	An internal error has occurred.
# 5026	Invalid Wininet offset	POLi is unable to verify the bank's security certificate. The bank website may be currently unavailable.	Retry payment at a later time.
# 5027	Platform not supported	Your computer does not support the POLi Payment System.
# 5028	Potential Westpac session corruption	An internal error has occurred.
# 5029	User is attempting to pay an unsaved payee using a mobile vector which does not support unsaved payees	The user's bank requires a saved payee.	Retry the payment using a desktop operating system.
# 5030	ThreatMetrix rejected this user	An error has occurred. Please contact the merchant for more information.
# 5040	Blacklisted Account	An error has occurred. Please contact the merchant for further information.
# 8001	Operational Error Without Trace Information	An operational error occurs but there is no trace information available.	Perform the web service again.
# 8002	Operational Error With Trace Information	An operational error occurs and trace information is available.	Perform the web service again.
# 8003	Invalid Field Characters	The specified field contains invalid characters.	There may be an error in the implementation of POLi™. Check your web services.
# 8004	Mandatory Field	No value is supplied for a mandatory field.	There may be an error in the implementation of POLi™. Check your web services.
# 8005	Invalid Field Length	The specified field has an invalid length.	There may be an error in the implementation of POLi™. Check your web services.
# 8006	Invalid Currency Amount In Field	The specified field contains invalid currency amount.	There may be an error in the implementation of POLi™. Check your web services.
# 8007	Invalid Field Range	The value in the field is out of the allowable range.	There may be an error in the implementation of POLi™. Check your web services. Please contact POLi Support if the issue persists.
# 11002	Unable to Send Nudge	A nudge sent to the merchant has failed.	The Nudge Notification URL may be publicly inaccessible, misconfigured, or the destination is down or taking too long to respond.
# 12001	Merchant Code Required	Merchant code is empty	Provide a non-empty merchant code
# 12002	Merchant Code Length	Merchant code length exceeds maximum number of characters allowed.	Provide a Merchant Code with valid length.
# 12003 or 1003	Invalid Merchant Code	Merchant Code doesn’t exist or inactive	Provide a valid Merchant Code.
# 12004	Authentication Code Required	Authentication Code is empty	Provide a non-empty Authentication Code
# 12005	Authentication Code Length	Authentication Code length exceeds maximum number of characters allowed.	Provide an Authentication Code with valid length.
# 12006 or 1005	Invalid Authentication Code	Authentication Code is not valid	Provide a valid Authentication Code.
# 12010	Request Type is Required	Request Type is empty	Provide a non-empty Request Type
# 12011	Request Type Length	Request Type length exceeds maximum number of characters allowed.	Provide a Request Type with a valid length
# 12012	Invalid Request Type	Request Type is not valid. It must be either Manual or Email.	Provide a Request Type set to either Manual or Email.
# 12013	Invalid Payment Amount	Payment Amount is empty. Either it is empty or not a decimal number or decimal precision exceeds 2 or not in the range of 1.00 and 10000.00	Provide a valid Payment Amount.
# 12014	Payment Reference is required	Payment reference is empty.	Provide a non-empty Payment Reference.
# 12015	Invalid Payment Reference	Payment reference is not valid.
# 12016	Invalid Confirmation Email	Confirmation Email is either empty or not one of the values Yes, No	Provide Confirmation Email with a valid value.
# 12017	Invalid Customer Reference	Customer Reference is either empty or not one of the values Yes, No	Provide Customer Reference with a valid value.
# 12018	Recipient Name is required	Recipient Name is empty.	Provide a non-empty Recipient Name.
# 12019	Recipient Name Length	Recipient Name length exceeds maximum number of characters allowed	Provide a Recipient Name with a valid length.
# 12020	Invalid Recipient Name	Recipient Name is not valid.	Check invalid characters in the Recipient Name.
# 12021	Recipient Email is required	Recipient Email is empty.	Provide a non-empty recipient email.
# 12022	Recipient Email Length	Recipient Email length exceeds maximum number of characters allowed.	Provide a Recipient Email with a valid length.
# 12023	Invalid Recipient Email	Recipient Email is not valid.	Check Recipient Email follows email address rules.
# 12024	Email Delivery Failed	Email Delivery to Payer failed.	Check payer email address is valid and active.
# 14050	A transaction-specific error has occurred	System Error	Contact POLi support.
# 14053	The amount specified exceeds the individual transaction limit set by the merchant	Validation issue	Either raise the limit or lower the amount for the transaction.
# 14054	The amount specified will cause the daily transaction limit to be exceeded	Validation issue	Either raise the limit or lower the amount for the transaction.
# 14055	General failure to initiate a transaction	System Error	Contact POLi support.
# 14056	Error in merchant-defined data	Validation issue	Check the length of the MerchantData field.
# 14057	One or more values specified have failed a validation check	Validation issue	Check that you have met the validation rules.
# 14058	The monetary amount specified is invalid	Validation issue	Check that the amount is in the correct format.
# 14059	A URL provided for one or more fields was not formatted correctly	Validation issue	Check the URL formats.
# 14060	The currency code supplied is not supported by POLi or the specific merchant	Validation issue	Please provide only AUD or NZD.
# 14061	The MerchantReference field contains invalid characters	Validation issue	MercantReference can only contain alphanumeric and these symbols:@-_=:?./
# 14062	One or more fields that are mandatory did not have values specified	Validation issue	Please provide all mandatory fields.
# 14099	An unexpected error has occurred within transaction functionality	System Error	Contact POLi support.
